--replaced getglobal
TBOX_Scale = 100
TBOX_KnownSpells = {}
TBOX_Tips = 1
TBOX_Disable = 0

function TotemBox_OnLoad(self)
	SLASH_TotemBox1 = "/totembox"  
	SLASH_TotemBox2 = "/tbox"  
	SlashCmdList["TotemBox"] = function(msg)
	TotemBox_Handler(msg)
	end
  
	if( DEFAULT_CHAT_FRAME ) then
	DEFAULT_CHAT_FRAME:AddMessage("TotemBox Loaded - Type /tbox help",1, 0, 0)
	end
	self:RegisterEvent("PLAYER_LOGIN")
	self:RegisterEvent("LEARNED_SPELL_IN_TAB")
	self:RegisterEvent("ACTIONBAR_UPDATE_USABLE")
	self:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN")
	self:RegisterEvent("PLAYER_TOTEM_UPDATE");
end

function TotemBox_OnEvent(self, event, ...)
	if (event == "PLAYER_LOGIN") then
		if UnitClass("player") == "Shaman" then
			if TBOX_EditPanel == nil then
			TBOX_EditPanel = {} -- fill edit panels with spells
				for i = 1 ,24 do
				TBOX_EditPanel[i] = TOTEMBOX_SPELLS[i]
				end
			end
		TotemBoxSpells() -- find what spells are in the spellbook	
		TotemBoxMakeButtons() -- make 24 buttons
		TBOXFillPanel() -- fill in edit boxes
		TBOX_Icons() -- put spell icons in buttons
		TBOX_SetScale() -- set totembox scale
		else TotemBox:Hide()
		DisableAddOn("TotemBox")
		return
		end
	end
	if (event == "ACTIONBAR_UPDATE_USABLE" or event == "ACTIONBAR_UPDATE_COOLDOWN") then
		if UnitClass("player") == "Shaman" then
		TotemBox_Cooldown() -- makes the cooldown effect
		end
	end
	if event == "LEARNED_SPELL_IN_TAB" then
		if UnitClass("player") == "Shaman" then
		TotemBoxSpells()
		TBOX_Icons()
		end
	end
	if event == "PLAYER_TOTEM_UPDATE" then
		if TBOX_Disable == 1 then
			for i = 1, 4 do
			_G["TotemFrameTotem"..i]:Hide()
			end
		end
	end
end

function TotemBoxSpells() -- find spells in spellbook and save spellID
	TBOX_KnownSpells = {}
	for i = 1, 300 do
	local spellName = GetSpellInfo(i, BOOKTYPE_SPELL)
		if spellName ~= nil then
			if string.find(spellName, "Totem") then
			TBOX_KnownSpells[spellName] = i -- i = spellid
			end
		end
	end
end

function TotemBoxMakeButtons() -- make those 24 buttons
	for i = 1,6 do
	local button = CreateFrame("Button","TotemButton"..i,TotemBox,"TotemBoxButtonTemplate")
	button:SetID(i)
	button:SetPoint("TOPLEFT",TotemBox,(36*(i-1))+10,-10)
	end
	for i = 7, 12 do
	local button = CreateFrame("Button","TotemButton"..i,TotemBox,"TotemBoxButtonTemplate")
	button:SetID(i)
	button:SetPoint("TOPLEFT",TotemBox,(36*(i-7))+10,-47)
	end
	for i = 13, 18 do
	local button = CreateFrame("Button","TotemButton"..i,TotemBox,"TotemBoxButtonTemplate")
	button:SetID(i)
	button:SetPoint("TOPLEFT",TotemBox,(36*(i-13))+10,-84)
	end
	for i = 19, 24 do
	local button = CreateFrame("Button","TotemButton"..i,TotemBox,"TotemBoxButtonTemplate")
	button:SetID(i)
	button:SetPoint("TOPLEFT",TotemBox,(36*(i-19))+10,-121)
	end
end
	
function TBOX_Icons() -- fill in spell icons & set the spell to be cast
	for i = 1, 24 do
		if TBOX_SpelltoIcons[TBOX_EditPanel[i]] ~= nil then
		_G["TotemButton"..i.."Icon"]:SetTexture(TBOX_SpelltoIcons[TBOX_EditPanel[i]])
		_G["TotemButton"..i]:Show()
		_G["TotemButton"..i]:SetAlpha(1)
		local frame = _G["TotemButton"..i]
		local spell = _G["TBOX_Edit"..i]:GetText()
		frame:SetAttribute("spell1", spell)
			if TBOX_KnownSpells ~= nil then
				if TBOX_KnownSpells[TBOX_EditPanel[i]] == nil then --if spell not known then alpha
				_G["TotemButton"..i]:SetAlpha(.4)
				end
			end
		else _G["TotemButton"..i]:Hide()-- hide the button if the spellname is blank or wrong
		end
	end
end

function TotemBox_Cooldown() -- makes that cool cooldown effect
	for i = 1, 24 do
	local usable, nomana = IsUsableSpell(TBOX_EditPanel[i])
		if usable then -- prevents lua nil error in Cooldown
		local cooldown = _G["TotemButton"..i.."Cooldown"]
		local start, duration, enable = GetSpellCooldown(TBOX_EditPanel[i])
		CooldownFrame_SetTimer(cooldown, start, duration, enable)
		end
	end
end

function TBOXFillPanel() -- fill in editboxes 
	for i = 1, 24 do
	_G["TBOX_Edit"..i]:SetText(TBOX_EditPanel[i])
	end
end

function TotemBox_OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_BOTTOMRIGHT")
	local id = self:GetID()
	local totemName = TBOX_EditPanel[id]
	if IsShiftKeyDown() then
	local spellid = TBOX_KnownSpells[totemName]
		if spellid ~= nil then
		GameTooltip:SetSpellBookItem(spellid, BOOKTYPE_SPELL)
		else GameTooltip:SetText(totemName.."  not trained", 1,1,1,1)
		end
	else	
		if TBOX_Tips == 1 then
		GameTooltip:SetText(totemName, 1,1,1,1)
		end
	end
end

function TotemBox_OnLeave()
	GameTooltip:Hide()
end

function TBOX_SetScale() -- slider code
	TotemBox:SetScale(TBOX_Scale/100)
end

function TBOX_InitSlider(slider) -- slider code
    _G["TBOX_SCALE_Slider" .. "Low"]:SetText("50")
	_G["TBOX_SCALE_Slider" .. "High"]:SetText("100") 
	_G["TBOX_SCALE_Slider" .. "Text"]:SetText(TBOX_Scale)
end

function TBOX_Change(self) -- slider code
	_G[self:GetName().."Text"]:SetText(_G[self:GetName()]:GetValue())
	TBOX_Scale = _G[self:GetName().."Text"]:GetText(_G[self:GetName()]:GetValue())
	TotemBox:SetScale(TBOX_Scale/100)
end

function TBOX_SaveEditBoxes() -- from config panel
	for i = 1, 24 do
	TBOX_EditPanel[i]= _G["TBOX_Edit"..i]:GetText();
	end
	TBOXFillPanel()
	TBOX_Icons()
	TBOX_SetScale()
end

function TotemBox_Handler(msg)
	if msg == "bell" then
	PlaySoundFile("Sound\\Doodad\\BellTollHorde.wav")
	elseif msg == "toggle" then
		if TotemBox:IsVisible() then
		TotemBox:Hide()
		else TotemBox:Show()
		end
	elseif msg == "disable" then
	TBOX_Disable = 1
	elseif msg == "enable" then
	TBOX_Disable = 0
	elseif msg == "hide" then
	TotemBox:Hide()
	elseif msg == "show" then
	TotemBox:Show()
	elseif msg == "config" or msg == "configure" then
	TBOXPanel:Show()
	elseif msg == "notips" then
	TBOX_Tips = 0
	elseif msg == "tips" then
	TBOX_Tips = 1
	elseif msg == "scale" then
	_G["TBOX_SCALE_Slider" .. "Text"]:SetText(TBOX_Scale)
	_G["TBOX_SCALE_Slider"]:SetValue(TBOX_Scale)
	_G["TBOX_SCALE"]:Show()
	elseif msg == "" or msg == "help" then
	TotemBox_Out("/tbox tips - turn on short tooltips")
	TotemBox_Out("/tbox notips - turn off short tooltips")
	TotemBox_Out("Holding SHIFT while mousing over totems shows full tooltips")
	TotemBox_Out("/tbox scale - brings up a slider")
	TotemBox_Out("/tbox config - brings up configuration panel")
	TotemBox_Out("/tbox hide - hides the totem box")
	TotemBox_Out("/tbox show - shows the totem box")
	TotemBox_Out("/tbox disable - disables Blizzard timer icons")
	TotemBox_Out("/tbox enable - enables Blizzard timer icons")
	TotemBox_Out("/tbox toggle - toggles TotemBox visible/invisible")
	TotemBox_Out("To move the whole box -SHIFT/LEFT CLICK upper left corner and drag")
	TotemBox_Out("To move a single button -SHIFT/LEFT CLICK on it and drag")
	end
end

function TotemBox_Out(text)
	DEFAULT_CHAT_FRAME:AddMessage(text)
end
		
TOTEMBOX_SPELLS= {
"Searing Totem",
"Magma Totem",
"Fire Nova Totem",
"Flametongue Totem",
"Frost Resistance Totem",
"Elemental Ristance Totem",
"Stoneskin Totem",
"Strength of Earth Totem",
"Tremor Totem",
"Earthbind Totem",
"Stoneclaw Totem",
"Earth Elemental Totem",
"Healing Stream Totem",
"Mana Tide Totem",
"Mana Spring Totem",
"Cleansing Totem",
"Fire Resistance Totem",
"Wrath of Air Totem",
"Windfury Totem",
"Nature Resistance Totem",
"Grounding Totem",
"Sentry Totem",
"Totem of Wrath",
"Totem of Tranquil Mind",
}
TBOX_SpelltoIcons = {
["Cleansing Totem"]="Interface\\Icons\\Spell_Nature_DiseaseCleansingTotem",
["Searing Totem"]="Interface\\Icons\\Spell_Fire_SearingTotem",
["Magma Totem"]="Interface\\Icons\\Spell_Fire_SelfDestruct",
["Fire Nova Totem"]="Interface\\Icons\\Spell_Fire_SealOfFire",
["Flametongue Totem"]="Interface\\Icons\\Spell_Nature_GuardianWard",
["Frost Resistance Totem"]="Interface\\Icons\\Spell_FrostResistanceTotem_01",
["Fire Elemental Totem"]="Interface\\Icons\\Spell_Fire_Elemental_Totem",
["Stoneskin Totem"]="Interface\\Icons\\Spell_Nature_StoneskinTotem",
["Strength of Earth Totem"]="Interface\\Icons\\Spell_Nature_EarthBindTotem",
["Tremor Totem"]="Interface\\Icons\\Spell_Nature_Tremortotem",
["Earthbind Totem"]="Interface\\Icons\\Spell_Nature_StrengthOfEarthTotem02",
["Stoneclaw Totem"]="Interface\\Icons\\Spell_Nature_StoneClawTotem",
["Earth Elemental Totem"]="Interface\\Icons\\Spell_Nature_EarthElemental_Totem",
["Healing Stream Totem"]="Interface\\Icons\\INV_Spear_04",
["Mana Tide Totem"]="Interface\\Icons\\Spell_Frost_SummonWaterElemental",
["Mana Spring Totem"]="Interface\\Icons\\Spell_Nature_ManaRegenTotem",
["Disease Cleansing Totem"]="Interface\\Icons\\Spell_Nature_DiseaseCleansingTotem",
["Poison Cleansing Totem"]="Interface\\Icons\\Spell_Nature_PoisonCleansingTotem",
["Elemental Resistance Totem"]="Interface\\Icons\\Spell_FireResistanceTotem_01",
["Wrath of Air Totem"]="Interface\\Icons\\Spell_Nature_SlowingTotem",
["Grace of Air Totem"]="Interface\\Icons\\Spell_Nature_InvisibilityTotem",
["Windfury Totem"]="Interface\\Icons\\Spell_Nature_Windfury",
["Tranquil Air Totem"]="Interface\\Icons\\Spell_Nature_Brilliance",
["Nature Resistance Totem"]="Interface\\Icons\\Spell_Nature_NatureResistanceTotem",
["Grounding Totem"]="Interface\\Icons\\Spell_Nature_GroundingTotem",
["Windwall Totem"]="Interface\\Icons\\Spell_Nature_Earthbind",
["Sentry Totem"]="Interface\\Icons\\Spell_Nature_RemoveCurse",
["Totem of Wrath"]="Interface\\Icons\\Spell_Fire_TotemOfWrath",
["Totem of Tranquil Mind"]="Interface\\Icons\\spell_nature_brilliance",
}